lab7/myimgur/app/urls.py
from django.urls import path

from . import views

app_name = 'app'
urlpatterns = [
    path('', views.index, name='index'),
    path('<int:image_id>/', views.detail, name='detail'),
    path('<int:image_id>/comment', views.comment, name='comment'),
    path('<int:image_id>/upvote', views.upvote, name='upvote'),
    path('<int:image_id>/downvote', views.downvote, name='downvote'),
    path('<int:image_id>/approve', views.approve, name='approve'),
    path('<int:image_id>/<int:comment_id>/like', views.like, name='like'),
    path("new", views.create_image, name="create_image"),
    path("<int:image_id>/edit", views.update_image, name="edit_image"),
    path("<int:image_id>/delete", views.delete_image, name="delete_image"),
]

lab7/myimgur/imgur/urls.py
from django.contrib import admin
from django.urls import include,path
from app import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('accounts.urls')),
    path('accounts/', include('django.contrib.auth.urls')),
    path('images/', include('app.urls')),
    path('', views.index, name='index'), 
]

lab7/myimgur/app/templates/includes/approve_button.html
<div>
<form action='{% url 'app:approve' image.id %}' method='post' role='form'>
    {% csrf_token %}
    <input type="hidden" name="id" value="{{ comment.id }}">
    <input type="submit" value="Approve" class="btn {{ comment.approved|yesno:'btn-success,btn-primary' }}">
  </form>
</div>

lab7/myimgur/app/templates/includes/bs4_form.html
{% load widget_tweaks %} 

{% for hidden_field in form.hidden_fields %}
      {{ hidden_field }}
    {% endfor %}
  
    {% if form.non_field_errors %}
      <div class="alert alert-danger" role="alert">
        {% for error in form.non_field_errors %}
          {{ error }}
        {% endfor %}
      </div>
    {% endif %}
  
    {% for field in form.visible_fields %}
      <div class="row form-group">
          <div class="col-md-8 contorls mx-auto">
            {{ field.label_tag }}
    
            {% if form.is_bound %}
            {% if field.errors %}
                {% render_field field class="form-control is-invalid" %}
                {% for error in field.errors %}
                <div class="invalid-feedback">
                    {{ error }}
                </div>
                {% endfor %}
            {% else %}
                {% render_field field class="form-control is-valid" %}
            {% endif %}
            {% else %}
            {% render_field field class="form-control" %}
            {% endif %}
    
            {% if field.help_text %}
            <small class="form-text text-muted">{{ field.help_text }}</small>
            {% endif %}
        </div>
      </div>
    {% endfor %}

lab7/myimgur/app/templates/includes/delete_image_link.html
<a href="#" id="delete_{{ image.id }}">Delete</a>
<form action="{% url 'app:delete_image' image.id %}" method='post' id="delete_form_{{ image.id }}" class="hidden">
  {% csrf_token %}
</form>
<script charset="utf-8">
  $(document).on('click','#delete_{{image.id}}', function(){
    $('#delete_form_{{image.id}}').submit();
  });
</script>

lab7/myimgur/app/templates/includes/like_buttons.html
<form action='{% url 'app:like' image.id  comment.id %}' method='post' role='form'>
    {% csrf_token %}
    {% for like in likes%}
    {% if like.comment.id == comment.id %}
        <span>Liked</span>  
    {% endif %}
    {% endfor %}
    <input type="submit" value="Like" class="btn btn-primary }}">
    
</form>

lab7/myimgur/app/templates/includes/vote_buttons.html
<div>
    <form action='{% url 'app:upvote' image.id %}' method='post' role='form' class='form-inline float-left'>
      {% csrf_token %}
      <input type="submit" value="+" class="btn {{ vote.upvote|yesno:'btn-success,btn-primary' }}">
    </form>
      <span class="vote-score float-left">{{ image.vote_score }}</span>
    <form action='{% url 'app:downvote' image.id %}' method='post' role='form' class='form-inline float-left'>
      {% csrf_token %}
      <input type="submit" value="-" class="btn {{ vote.downvote|yesno:'btn-danger,btn-primary' }}">
    </form>
  </div>

lab7/myimgur/app/templates/includes/votes.html
<div>
      <span class="vote-score float-left">Number of votes: {{ image.vote_score }}</span>
</div>